package ValueLib;

import java.util.Comparator;

public class Value extends Printer implements Scalable, Moveable, Comparable<Value> {
	protected int a;
	protected int b;
	static int count = 0;

	public Value() {
		this(0, 0);
		//System.out.println("Value() constructor=" + getName());
	}

	public Value(int[] value) {
		this(value[0], value[1]);
		//System.out.println("Value(int[]) constructor=" + getName());
	}

	public Value(int a, int b) {
		super("Value" + (++count));
		set(a, b);
		//System.out.println("Value(int, int) constructor=" + getName());
	}
	
	public void set(Value ab) { // set 
		this.a = ab.getA();
		this.b = ab.getB();
	}
	
	public void set(int a, int b) { // set 
		this.a = a;
		this.b = b;		
	}
	
	public int getA() {
		return this.a;
	}
	
	public int getB() {
		return this.b;
	}

	public static void resetCount() {
		count = 0;
	}

	public static int getCount() {
		return count;
	}

	@Override
	public void print() {
		System.out.println(getName() + " (" + this.a + "," + this.b + ")");	
	}

	@Override // Object toString()
	public String toString() {
		return getName() + " (" + this.a + "," + this.b + ")";
	}

	@Override
	public void scale(int factor) {
		this.a *= factor;
		this.b *= factor;	
	}

	@Override
	public void move(int x, int y) {
		this.a += x;
		this.b += y;	
	}

	@Override
	public int compareTo(Value other) {
		// TODO Auto-generated method stub
		//return this.a - other.a;
		return Integer.compare(this.a, other.getA());
	}
	// Comparator
	public static Comparator<Value> BComparator = new Comparator<Value>() {
		@Override
		public int compare(Value v1, Value v2) {
			// TODO Auto-generated method stub
			return Integer.compare(v1.getB(), v2.getB());
		}		
	};

	@Override // Object equals
	public boolean equals(Object obj) {
		if (obj instanceof Value) {
			return equals((Value)obj);
		}
		return false;
	}
	public boolean equals(Value other) {
		if (this.a == other.getA() && this.b == other.getB()) {
			return true;
		}
		return false;
	}
	
	@Override // Object hashCode
	public int hashCode() {
		return Integer.valueOf(this.a).hashCode() 
				* Integer.valueOf(this.b).hashCode();
	}
}
