package ValueLib;
import java.util.*;

public class Value3D extends Value {
	// instance member field
	protected int c;

	// constructor
	public Value3D() {
		this(0, 0, 0);
	}

	public Value3D(int a, int b, int c) {
		super(a, b);
		this.c = c;
	}

	public void set(int a, int b, int c) { 
		super.set(a, b); 
		this.c = c; 
	}
	
	public void setC(int c) { 
		this.c = c; 
	}

	public int getC() { 
		return c; 
	}

	public void move(int x, int y, int z) { 
		super.move(x, y); 
		this.c += z; 
	}
	
	@Override // print method override of Point class
	public void print() { 
		System.out.println(getName() + " (" + this.a + "," + this.b + "," + this.c + ")"); 
	}

	@Override // toString method override of Object class
	public String toString() { 
		return getName() + "(" + this.a + " , " + this.b + " , " + this.c + ")"; 
	} 

	@Override // equals method override of Object class
	public boolean equals(Object obj) {
		if (!(obj instanceof Value3D))
			return false;
		return equals((Value3D)obj);
	}
	// equals method
	public boolean equals(Value3D other) {
		if (this.a == other.a && this.b == other.b && this.c == other.c)
			return true;
		return false;
	}
	// compare implementation of Comparator interface
    public static Comparator<Value> CComparator = new Comparator<Value>() {
		public int compare(Value v1, Value v2) {
			return Integer.compare(((Value3D)v1).getC(), ((Value3D)v2).getC()); //ascending order by C
		}
	};
}
